#include <bits/stdc++.h>
using namespace std;

using ll = long long;


constexpr int MOD = 1e9 + 7;


struct Fenwick {
    vector<ll> fen;
    ll n;

    Fenwick(vector<ll>& a) {
        n = a.size();
        fen.assign(n + 1, 0);

        for (int i = 1; i <= n; i++) {
            fen[i] = (fen[i] + a[i]) % MOD;
            if (i + (i & (-i)) <= n) {
                fen[i + (i & (-i))] = (fen[i + (i & (-i))] + fen[i]) % MOD;
            }
        }
    }

    Fenwick(ll m) {
        n = m;
        fen.assign(n + 1, 0);
    }

    ll pref(ll r) {
        ll ans = 0;
        while (r > 0) {
            ans = (ans + fen[r]) % MOD;
            r -= (r & (-r));
        }
        return ans;
    }

    ll query(ll l, ll r) {
        return (pref(r) - pref(l - 1) + MOD) % MOD;
    }

    void update(int i, ll val) {
        int j = i;

        while (j <= n) {
            fen[j] = (fen[j] + val) % MOD;
            j += (j & (-j));
        }
    }
};


struct query {
    ll l, r, i;
    bool operator<(query& quer) {
        return l < quer.l;
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q, t;
    cin>>n>>q>>t;


    ll sum[n + 1] = {};
    ll sumsq[n + 1] = {};

    for (int i = 1; i <= n; i++) {
        sum[i] = (sum[i - 1] + i) % MOD;
        sumsq[i] = (sumsq[i - 1] + i * i) % MOD;
    }

    int a[n + 1];
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }

    int b[n + 1] = {};

    stack<int> s;
    for (int i = 1; i <= n; i++) {
        while (!s.empty() && a[s.top()] <= a[i]) {
            if (a[s.top()] == a[i]) {
                b[i] = s.top();
            }
            s.pop();
        }
        if (!s.empty() && b[i] == 0) {
            b[i] = s.top();
        }
        s.push(i);
    }


    vector<ll> reg(n + 1), mult(n + 1);

    vector<int> events[n + 1];

    for (int i = 1; i <= n; i++) {
        reg[i] = b[i];
        mult[i] = b[i] * i;

        events[b[i] + 1].push_back(i);
    }

    Fenwick fenreg = Fenwick(reg);
    Fenwick fenmult = Fenwick(mult);
    Fenwick fentimes = Fenwick(n + 1);
    Fenwick fensum = Fenwick(n + 1);
    

    if (t == 1) {
        query quer[q];
        for (int i = 0; i < q; i++) {
            cin >> quer[i].l >> quer[i].r;
            quer[i].i = i;
        }
        sort(quer, quer + q);

        ll res[q];

        int nxtl = 1;

        for (int i = 0; i < q; i++) {
            while (nxtl <= quer[i].l) {
                for (int j : events[nxtl]) {
                    fenreg.update(j, -reg[j]);
                    fenmult.update(j, -mult[j]);
                    fentimes.update(j, 1);
                    fensum.update(j, j);
                }
                nxtl++;
            }

            int l = quer[i].l, r = quer[i].r;

            ll ans = (((sum[r] - sum[l - 1] + MOD) % MOD) * r) % MOD;
            ans = (ans - ((sumsq[r] - sumsq[l - 1] + MOD) % MOD) + MOD) % MOD;
            ans = (ans + ((sum[r] - sum[l - 1] + MOD) % MOD)) % MOD;
            ll summ = (fenreg.query(l, r) + (l - 1) * fentimes.query(l, r)) % MOD;
            ans = (ans - r * summ + MOD) % MOD;
            ll summ2 = (fenmult.query(l, r) + (l - 1) * fensum.query(l, r)) % MOD;
            ans = (ans + summ2) % MOD;
            ans = (ans - summ + MOD) % MOD;
            res[quer[i].i] = ans;
        }

        for (int i = 0; i < q; i++) {
            printf("%lld\n", res[i]);
        }
    }
    else {
        assert(false);
    }
    
}
