#include <iostream>
#include <vector>

using namespace std;
typedef long long ll;

const ll md = 1'000'000'007;
vector<ll> fac;

ll pw(ll a, ll k) {
	ll res = 1;
	while (k) {
		if (k % 2)
			res = res * a % md;
		a = a * a % md;
		k /= 2;
	}
	return res;
}

ll C(ll n, ll k) {
	if (k < 0 || k > n)
		return 0;
	return fac[n] * pw(fac[k] * fac[n - k] % md, md - 2) % md;
}

ll K(ll n, ll k) {
	if (n == 0 && k == 0)
		return 1;
	return (md + C(n - 1, k) - C(n - 1, k - 2)) % md;
}
int main() 
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	fac.resize(400'007);
	fac[0] = 1;
	for (int i = 1; i < 400'007; i++)
		fac[i] = fac[i - 1] * i % md;
	int n;
	cin >> n;
	vector<int> a(n * 2 + 1, -1);
	for (int i = 0; i < 2; i++)
		for (int j = 0; j < n; j++) {
			int v;
			cin >> v;
			if (!v)
				continue;
			a[v - 1] = j + i * n;
			if (v == j * 2 + 1 && i) {
				cout << "0\n";
				return 0;
			}
		}
	a[2 * n - 1] = 2 * n - 1;
	vector<vector<ll>> dp(2 * n + 1, vector<ll>(n + 1));
	dp[0][0] = 1;
	for (int i = 1; i <= n * 2; i++) {
		if (a[i - 1] == -1) {
			for (int j = (i + 1) / 2; j <= n; j++)
				dp[i][j] = (dp[i - 1][j] + dp[i - 1][j - 1]) % md;
			continue;
		}
		int J;
		if (a[i - 1] < n)
			J = a[i - 1];
		else
			J = i - 1 - (a[i - 1] - n);
		if (a[i - 1] < n)
			dp[i][J + 1] = dp[i - 1][J];
		else
			dp[i][J] = dp[i - 1][J];
	}
	cout << dp[2 * n][n] << "\n";
}