#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define int ll
using pii = pair<int, int>;
using pll = pair<ll, ll>;
const int mod = 1e9 + 7;

struct ST{
    vector<vector<pii>> t;
    vector<vector<ll>> p1, p2, p3;
    vector<int> a;
    vector<int> :: iterator it;
    int n;
    void build(int v, int tl, int tr){
        if (tl == tr){
            t[v] = {{a[tl], tl}};
            p1[v] = {0, tl};
            p2[v] = {0, (1LL * tl * a[tl]) % mod};
            p3[v] = {0, a[tl]};
            return;
        }
        int tm = (tl + tr) / 2, vv = 2 * v;
        build(vv, tl, tm);
        build(vv + 1, tm + 1, tr);
        t[v].resize(tr - tl + 1);
        merge(t[vv].begin(), t[vv].end(), t[vv + 1].begin(), t[vv + 1].end(), t[v].begin());
        p1[v].resize(tr - tl + 2);
        p2[v].resize(tr - tl + 2);
        p3[v].resize(tr - tl + 2);
        p1[v][0] = p2[v][0] = p3[v][0] = 0;
        for (int i = 1; i <= t[v].size(); i++){
            p1[v][i] = (p1[v][i - 1] + t[v][i - 1].second) % mod;
            p2[v][i] = (p2[v][i - 1] + 1LL * t[v][i - 1].second * t[v][i - 1].first) % mod;
            p3[v][i] = (p3[v][i - 1] + t[v][i - 1].first) % mod;
        }
    }
    ST(int ns, vector<int>& as){
        n = ns;
        a = as;
        t.resize(4 * n);
        p1.resize(4 * n);
        p2.resize(4 * n);
        p3.resize(4 * n);
        build(1, 1, n);
    }
    pll comb(pll x, pll y){
        return {(x.first + y.first) % mod, (x.second + y.second) % mod};
    }
    pll get(int v, int tl, int tr, int& l, int& r, int& k){
        if (l > tr || r < tl) return {0, 0};
        if (l <= tl && tr <= r){
            int bl = 0, br = tr - tl;
            while (bl + 1 < br){
                int m = (bl + br) / 2;
                if (t[v][m].first > k){
                    br = m;
                }
                else {
                    bl = m + 1;
                }
            }
            if (t[v][bl].first > k) br = bl;
            int i = br;
            ll f = (1LL * k * i + (p3[v].back() - p3[v][i])) % mod;
            ll s = (1LL * k * p1[v][i] + (p2[v].back() - p2[v][i])) % mod;
            return {f, s};
        }
        int tm = (tl + tr) / 2, vv = 2 * v;
        return comb(get(vv, tl, tm, l, r, k), get(vv + 1, tm + 1, tr, l, r, k));
    }
    pll get(int l, int r, int k){
        return get(1, 1, n, l, r, k);
    }
};

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int n, m, t; cin>>n>>m>>t;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++){
        cin>>a[i];
    }
    vector<int> d(n + 1);
    stack<int> st;
    for (int i = n; i > 0; i--){
        while (!st.empty() && a[i] >= a[st.top()]){
            d[st.top()] = i;
            st.pop();
        }
        st.push(i);
    }
    for (int i = 1; i <= n; i++){
        d[i]++;
    }
    ST T(n, d);
    vector<ll> p1(n + 1), p2(n + 1);
    p1[0] = p2[0] = 0;
    for (int i = 1; i <= n; i++){
        p1[i] = (p1[i - 1] + i) % mod;
        p2[i] = (p2[i - 1] + 1LL * i * i) % mod;
    }
    while (m--){
        int l, r; cin>>l>>r;
        pll g = T.get(l, r, l);
        ll out = (r * (p1[r] - p1[l - 1]) - (p2[r] - p2[l - 1]) + (r - l + 1) * (r + 1)) % mod;
        ll s = ((r + 1) * g.first - g.second) % mod;
        out -= s;
        // cout<<g.first<<" "<<g.second<<"\n";
        cout<<(out % mod + mod) % mod<<"\n";
    }
}