#include <algorithm>
#include <climits>
#include <cmath>
#include <iostream>
#include <map>
#include <queue>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ul unsigned long
#define lf long double
#define nl "\n"
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

struct layer {
  pair<ll, ll> coords;
  vector<ll> possibilities;
};

struct variant {
  ll layer;
  map<ll, bool> used_nums;
  map<pair<ll, ll>, ll> values;
};

/*
2 - 2
3 - 5
4 - 14
5 - 42
6 - 132
7 - 429
*/

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  // freopen("in", "r", stdin);
  ll n, m, k;
  ll a, b, c, d, e, f, g, h, r, l, mx, mn, sm;
  bool bl;
  char ch;
  string str;
  cin >> n;
  ll arr[2][n];
  vector<bool> found(2 * n + 1, false);
  vector<pair<ll, ll>> empty_cells;
  for (ll i = 0; i < 2; i++) {
    for (ll j = 0; j < n; j++) {
      cin >> arr[i][j];
      if (arr[i][j] == 0) {
        empty_cells.push_back({i, j});
      } else {
        if (i == 1) {
          if (arr[0][j] > arr[1][j]) {
            cout << 0;
            return 0;
          }
        }
        if (j > 0) {
          if (arr[i][j - 1] > arr[i][j]) {
            cout << 0;
            return 0;
          }
        }
      }
      found[arr[i][j]] = true;
    }
  }
  if (empty_cells.size() == 0) {
    cout << 1;
    return 0;
  }
  if (empty_cells.size() == 2 * n) {
    n--;
    sm = 0;
    queue<pair<ll, ll>> search;
    search.push({0, 0});
    while (!search.empty()) {
      pair<ll, ll> current = search.front();
      search.pop();
      if (current.first == n && current.second == n) {
        sm++;
        continue;
      }
      if (current.first <= current.second) {
        search.push({current.first + 1, current.second});
      }
      if (current.second < n) {
        search.push({current.first, current.second + 1});
      }
    }
    cout << sm;
    return 0;
  }
  vector<ll> unused_numbers(empty_cells.size());
  b = 0;
  for (ll i = 1; i <= 2 * n; i++) {
    if (!found[i]) {
      unused_numbers[b] = i;
      b++;
    }
  }
  vector<layer> possibility_cells(empty_cells.size());
  layer tmp_layer;
  for (ll i = 0; i < empty_cells.size(); i++) {
    tmp_layer.possibilities = {};
    tmp_layer.coords = empty_cells[i];
    for (ll i : unused_numbers) {
      if (tmp_layer.coords.first == 1) {
        if (arr[0][tmp_layer.coords.second] > i) {
          continue;
        }
      } else {
        if (arr[1][tmp_layer.coords.second] != 0 &&
            arr[1][tmp_layer.coords.second] < i) {
          continue;
        }
      }
      if (tmp_layer.coords.second > 0) {
        if (arr[tmp_layer.coords.first][tmp_layer.coords.second - 1] > i) {
          continue;
        }
      }
      if (tmp_layer.coords.second < n - 1) {
        if (arr[tmp_layer.coords.first][tmp_layer.coords.second + 1] != 0 &&
            arr[tmp_layer.coords.first][tmp_layer.coords.second + 1] < i) {
          continue;
        }
      }
      tmp_layer.possibilities.push_back(i);
    }
    possibility_cells[i] = tmp_layer;
  }
  sort(all(possibility_cells), [](layer layer1, layer layer2) {
    return layer1.possibilities.size() < layer2.possibilities.size();
  });
  queue<variant> variants;
  variant initial;
  initial.layer = 0;
  variants.push(initial);
  sm = 0;
  d = empty_cells.size();
  while (!variants.empty()) {
    variant current = variants.front();
    variants.pop();
    if (current.layer == d) {
      sm++;
      continue;
    }
    variant tmp = current;
    tmp.layer++;
    for (auto possibility : possibility_cells[current.layer].possibilities) {
      if (!current.used_nums[possibility]) {
        if (possibility_cells[current.layer].coords.first == 1) {
          if (current
                  .values[{0, possibility_cells[current.layer].coords.second}] >
              possibility)
            continue;
        } else {
          if (current.values[{
                  1, possibility_cells[current.layer].coords.second}] != 0 &&
              current.values[{1,
                              possibility_cells[current.layer].coords.second}] <
                  possibility)
            continue;
        }
        if (possibility_cells[current.layer].coords.second > 0) {
          if (current.values[{possibility_cells[current.layer].coords.first,
                              possibility_cells[current.layer].coords.second -
                                  1}] > possibility)
            continue;
        }
        if (possibility_cells[current.layer].coords.second < n - 1) {
          if (current.values[{possibility_cells[current.layer].coords.first,
                              possibility_cells[current.layer].coords.second +
                                  1}] != 0 &&
              current.values[{possibility_cells[current.layer].coords.first,
                              possibility_cells[current.layer].coords.second +
                                  1}] < possibility)
            continue;
        }
        tmp.used_nums[possibility] = true;
        tmp.values[possibility_cells[current.layer].coords] = possibility;
        variants.push(tmp);
        tmp.used_nums.erase(possibility);
        tmp.values.erase(possibility_cells[current.layer].coords);
      }
    }
  }
  cout << sm;
}
